/**************************************************************************
      nnw.h    -  used functions and types
      project  -  Nnw
      versiom  -  .03
      -------------------
     begin                : Wed Mar 29 2000
     copyright            : (C) 2001 by Ed van der Meulen
     email                : ameulen@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define memmx 3000		   // max number cels in celmem, NN
#define primx 5			   // max number cels in celpri, cp

// default file names
#define def_snnslet "snnslet"
#define def_nnlet "nn.tmp"
#define def_nn "nnnet"

// Cell structure:
struct celt
{
    int ad;                        // 0. address, position in the image + me
    int me;                        // 1. recognition value (input) of the cel
    int wei;                       // 2. weight of the cel
    int bi;                        // 3. sd of the input
    int mot;                       // 4. mother
    int sis;                       // 5. next in the llist of my sisters
    int dot;                       // 6. daughter
    int nan;                       // 7. Im a specialist and can return an answer
    int ans;                       // 8. answer as far as I know
    int mar;                       // 9. marge containing the answer
};
struct celt cel[memmx], cp[primx];

struct land
{
    unsigned b;                    // the world has categories of perception,
    unsigned c;                    // countries,bottoms and cellings of number area
};

int nnwcv(char *fin, char *fon);
int nnwshop(char *fon, char *fnnn);
void nnshop(FILE *flog, int *ct, int *tio, int *bio, int *cio, int *io);
int nnwdorm1(char *fin, char *fnnn);
int nnwdorm2(char *fin, char *fnnn);
int nnwview(char *fin);
